<template>
  <v-container
    fluid
    tag="section"
  >
    <material-card
      icon="mdi-cart-arrow-down"
      icon-small
      :title="$t('nuevaCompra')"
      color="secondary"
    >
      <v-row>
        <v-col cols="12" md="12" sm="12">
          <ComprasForm
            ref="compraForm"
            :compra="compraData"
            @onCompraGuardada="compraGuardada"
            @onCancelarGuardar="cancelarGuardado"
            @onTerminarCompra="terminarCompra"
          />
          <v-card-text style="height: 0px; position: relative">
            <v-fab-transition>
              <v-btn
                v-if="compraId > 0"
                color="accent"
                dark
                absolute
                top
                right
                fab
                @click="abrirDetalles"
              >
                <v-icon>mdi-plus</v-icon>
              </v-btn>
            </v-fab-transition>
          </v-card-text>
        </v-col>
      </v-row>
      <v-row>
        <v-col cols="12" md="12" sm="12">
          <DetalleCompraTabla
            ref="detalleTabla"
            :compraId="compraId"
            class="pl-4 pr-4"
          />
        </v-col>
      </v-row>
    </material-card>

    <v-navigation-drawer
      v-model="drawer"
      absolute
      temporary
      right
      width="60%"
      class="pt-2"
    >
      <v-card flat>
        <h2 class="pl-4 pb-4"> {{ $t('pedidos') }} </h2>
        <PedidosTabla
          v-if="compraId > 0"
          :esPedido="true"
          class="pt-2 pl-2"
          @onAgregarPedido="agregarPedido"
        />
      </v-card>
      <v-divider></v-divider>

    </v-navigation-drawer>
  </v-container>
</template>

<script>
import ComprasForm from '@/components/Compras/ComprasForm'
import DetalleCompraTabla from '@/components/Compras/DetalleCompraTabla'
import PedidosTabla from '@/components/Pedidos/PedidosTabla'
import PedidoServicio from '@/store/services/PedidoServicio'
export default {
  name: 'VistaNuevaCompra',
  components: {
    ComprasForm,
    DetalleCompraTabla,
    PedidosTabla
  },
  props: {
  },
  data () {
    return {
      modal: false,
      compraData: null,
      drawer: false,
      compraId: 0,
      dato: null
    }
  },
  methods: {
    nuevaCompra() {
      console.log('asd')
    },
    compraGuardada(value) {
      console.log(value)
      this.compraId = value.id
    },
    cancelarGuardado() {
      this.resetVistaCompra()
    },
    abrirDetalles() {
      this.drawer = true
    },
    guardarDetalle() {

    },
    agregarPedido(value)
    {
      this.guardarPedido(value)
    },
    async guardarPedido(value) {
      if (this.validarPedido(value)) {
        let response = await PedidoServicio.asignCompra(value.id, this.compraId)
        this.$refs.detalleTabla.refreshTable()
        console.log(response)
      }
    },
    validarPedido(pedido) {
      if (pedido.estado !== 'APROBADO' && pedido.autorizador_id === null) {
        alert(this.$t('elPedidoDebeSerAprobadoOYaFueComprado'))
        return false
      }
      return true
    },
    terminarCompra() {
      this.resetVistaCompra()
    },
    resetVistaCompra()
    {
      this.compraId = 0
      this.$refs.compraForm.resetData()
      this.$refs.detalleTabla.refreshTable()
    }
  }
}
</script>

<style>

</style>
